<?php

/**

EasyPhpMassEmail class version 0.0.1 - PHP5

Copyright (c) 2011 JF Nutbroek <jfnutbroek@gmail.com>
Visit http://www.mywebmymail.com for more information 

Permission to use, copy, modify, and/or distribute this software for any
purpose without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

*/


class easyphpmassemail {
	
	/**
	 * The array with email addresses
	 *
	 * @var array
	 */	
	public $Emailto;	
	/**
	 * The subject of the email
	 *
	 * @var string
	 */	
	public $Subject;	
	/**
	 * The complete message body of the email
	 *
	 * @var string
	 */	
	public $Message;
	/**
	 * The headers of the email
	 *
	 * @var string
	 */	
	public $Headers;	
	/**
	 * The maximum amount of emails to send per session
	 *
	 * @var int
	 */	
	public $Batchsize;
	/**
	 * Test Mode
	 *
	 * @var boolean
	 */	
	public $Testmode;	
	
	/**
	 * Class constructor
	 *
	 */
	public function __construct() {
	
		$this -> Emailto             = array();
		$this -> Subject             = '';
		$this -> Message             = '';
		$this -> Headers             = '';		
		$this -> Batchsize           = 5;
		$this -> Testmode            = false;
		
	}

	/**
	 * Prepare the mass email session
	 *
	 */	
	public function Preparemail() {

		if (count($this -> Emailto) > 0) {
			$_SESSION['epme_emailto'] = $this -> Emailto;
			$_SESSION['epme_subject'] = $this -> Subject;
			$_SESSION['epme_message'] = $this -> Message;
			$_SESSION['epme_headers'] = $this -> Headers;
			$_SESSION['epme_email_b'] = $this -> Batchsize;
			$_SESSION['epme_email_m'] = $this -> Testmode;
			$_SESSION['epme_email_t'] = count($this -> Emailto);
			$_SESSION['epme_email_f'] = array(); 
			return true;
		} else {
			return false;
		}

	}
	
	/**
	 * Cleanup the mass email session
	 *
	 */	
	public function Cleanup() {

		if (isset($_SESSION['epme_emailto'])) {
			unset($_SESSION['epme_emailto']);
			unset($_SESSION['epme_subject']);
			unset($_SESSION['epme_message']);
			unset($_SESSION['epme_headers']);
			unset($_SESSION['epme_email_b']);
			unset($_SESSION['epme_email_m']);
			unset($_SESSION['epme_email_t']);
			unset($_SESSION['epme_email_f']);
			return true;
		} else {
			return false;
		}
		
	}	
	
	/**
	 * Send a batch of emails
	 *
	 */	
	public function Sendemails() {

		if (isset($_SESSION['epme_emailto'])) {
			$size = min($_SESSION['epme_email_b'], count($_SESSION['epme_emailto']));
			for ($i = 0,$size; $i<$size; ++$i) {
				$lastkey = count($_SESSION['epme_emailto']) - 1;
				if (!$_SESSION['epme_email_m']) {
					if (!mail($_SESSION['epme_emailto'][$lastkey], $_SESSION['epme_subject'], wordwrap($_SESSION['epme_message'], 70), $_SESSION['epme_headers'])) {
						$_SESSION['epme_email_f'][] = $_SESSION['epme_emailto'][$lastkey];
					}
				} else {
					sleep(1);
				}
				array_pop($_SESSION['epme_emailto']);
			}
			if (count($_SESSION['epme_emailto']) < 1) {
				return false;
			} else {
				return true;
			}
		} else {
			return false;
		}
	
	}	
	
	/**
	 * Progress indication
	 * Optional string parameter $type returns:
	 * '%' : percentage completed
	 * 't' : total emails send
	 * 'r' : total emails remaining in queue
	 *
	 */	
	public function Progress($type = '%') {

		$progress = 'Inactive';
		if (isset($_SESSION['epme_emailto'])) {
			switch($type) {
				case '%':
					$progress = ceil(100 * (1 - (count($_SESSION['epme_emailto']) / $_SESSION['epme_email_t']))) . '%';
					break;
				case 't':
					$progress = $_SESSION['epme_email_t'] - count($_SESSION['epme_emailto']);
					break;
				case 'r':
					$progress = count($_SESSION['epme_emailto']);
					break;
			}
		}
		return $progress;
	
	}

	/**
	 * Return failed emails
	 *
	 */	
	public function Failed() {
	
		if (isset($_SESSION['epme_emailto'])) {
			return $_SESSION['epme_email_f'];
		} else {
			return array();
		}
	
	}

}


?>
